﻿local ADDONNAME, RepperData = ...
local VERSION = GetAddOnMetadata(ADDONNAME,"Version")
RepperData.Functions = {}
local MyFuncs = RepperData.Functions;
local _;

-- Variables
local showEvent = false;
local trackRepCheckBox = nil;
local RepList = {};
local variablesLoaded = false
local lastTime = 0
local BarID = 0
-- Bars are Squished, most have lost their uniqueness: consider increasing VSize
local BarTextures = {
	[00] = {Texture = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar", Name = "Default"},
	[01] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Aluminium", Name = "Aluminium"},
	[02] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Bantobar", Name = "Bantobar"},
	[03] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Charcoal", Name = "Charcoal"},
	[04] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Flat", Name = "Flat"},
	[05] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Frost", Name = "Frost"},
	[06] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Glaze", Name = "Glaze"},
	[07] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Healbot", Name = "Healbot"},
	[08] = {Texture = "Interface\\AddOns\\Repper\\Textures\\LiteStep", Name = "LiteStep"},
	[09] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Otravi", Name = "Otravi"},
	[10] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Rocks", Name = "Rocks"},
	[11] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Runes", Name = "Runes"},
	[12] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Smooth", Name = "Smooth"},
	[13] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Smudge", Name = "Smudge"},
	[14] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Striped", Name = "Striped"},
	[15] = {Texture = "Interface\\AddOns\\Repper\\Textures\\SWSDefault", Name = "SWSDefault"},
	[16] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Xeon", Name = "Xeon"},
	[17] = {Texture = "Interface\\AddOns\\Repper\\Textures\\Xus", Name = "Xus"},
 }

-- Slash Commands
SLASH_Repper1 = '/repper'

function Repper_OnLoad(self)
	self:RegisterEvent("ADDON_LOADED");						--AddOn Loaded
	self:RegisterEvent("PLAYER_ENTERING_WORLD");			--Player Loaded
	self:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");	--Faction Update
	self:RegisterEvent("CHAT_MSG_SYSTEM");					--New Faction Added
	self:RegisterEvent("QUEST_LOG_UPDATE");					--Quest Awards Rep
	self:RegisterEvent("PLAYER_LEAVE_COMBAT");				--Update after combat, cannot update during
	self:RegisterEvent("UNIT_AURA");
	self:RegisterAllEvents()
end

-- Event Handler
function Repper_OnEvent(self, event, ...)
	-- Starts the addon
	if showEvent then print(event) end
	if (event == "ADDON_LOADED") then
		if  (lastTime + 1 > time() and lastTime ~= 0) then return end;
		lastTime = time()
		if (...) == ADDONNAME then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00ff00"..ADDONNAME.." ".."|cffff0000"..VERSION.."|cff00ff00: Loaded.");
			RepList = CopyTable(RepperSVPC)
			if RepperSavedBar ~= nil then BarID = RepperSavedBar end
			if RepList ~= nil then
				for k,v in pairs(RepList) do 
					v.Frame = CreateFrame("StatusBar", k, REPPERFrame,"RBarTemplate")
				end
			end
		end
	--elseif event == "PLAYER_ENTERING_WORLD" then
	--	variablesLoaded = true;
	end
	MyFuncs.Update(false)
end

function Repper_CheckBox()
	local name, _, _, _, _, _, _, _, _, _, _, _, _, FactionID = GetFactionInfo(GetSelectedFaction())
	if RepList[name] ~= nil then
		RepList[name].Tracked = trackRepCheckBox:GetChecked()
	else
		RepList[name] = {Tracked = true, Frame = CreateFrame("StatusBar", name, REPPER,"RBarTemplate"), ID = FactionID}
	end
	MyFuncs.Update(true)
end

function MyFuncs.Update(forceUpdate)
	if  (lastTime + 1 > time() and lastTime ~= 0 and not forceUpdate) then return end;
	lastTime = time()
	local lastFrame = nil
	REPPER:SetHeight(15);
	-- Open all Headers
	local count = 1
	local collapsed = {}
	-- Update Tracker
	for k,v in pairs(RepList) do 
		if v.Tracked then
			local _, _, standingId, bottomValue, topValue, earnedValue = GetFactionInfoByID(v.ID)
			local barVal = earnedValue-bottomValue;
			local barMax = topValue-bottomValue;
			if (barMax == 0) then
				barVal = 1;
				barMax = 1;
			end
			v.Frame:Show()
			v.Frame.Text:SetText(k)
			v.Frame.Status:SetText(topValue-earnedValue);
			v.Frame:SetMinMaxValues(0,barMax);
			v.Frame:SetValue(barVal);
			v.Frame:SetStatusBarColor(FACTION_BAR_COLORS[standingId].r, FACTION_BAR_COLORS[standingId].g, FACTION_BAR_COLORS[standingId].b );
			v.Frame:SetStatusBarTexture(BarTextures[BarID].Texture)
			if lastFrame == nil then
				v.Frame:SetPoint("TOPLEFT", REPPER, "TOPLEFT", 11,-9)
			else
				v.Frame:SetPoint("TOPLEFT", lastFrame, "BOTTOMLEFT", 0,-4)
			end
			lastFrame = v.Frame
			REPPER:SetHeight(REPPER:GetHeight() + 16);
		else 
			v.Frame:Hide()
		end
	end
	-- Adjust Tracker frame height
	if REPPER:GetHeight() <= 15 then
		REPPER:Hide()
	else
		REPPER:Show()
	end
	RepperSVPC = CopyTable(RepList)
	RepperSavedBar = BarID
end

function MyFuncs.OnClick(self)
	if IsShiftKeyDown() then 
		-- Untrack This Rep
		RepList[self.Text:GetText()].Tracked = false
		MyFuncs.Update(true)
	end

end

function MyFuncs.HookDetailOnUpdate() 
	--print("Hook:OnUpdate")
	if not ReputationDetailFrame:IsShown() then return end;
	
	local name = GetFactionInfo(GetSelectedFaction())
	if RepList[name] ~= nil then
		trackRepCheckBox:SetChecked(RepList[name].Tracked)
	else
		trackRepCheckBox:SetChecked(false)
	end
	ReputationDetailFrame:SetHeight(225)
end
function MyFuncs.HookDetailOnShow() 
	--print("Hook:OnShow")
	if trackRepCheckBox==nil then
		trackRepCheckBox = CreateFrame("CheckButton", "trackRepCheckBox", ReputationDetailFrame, "OptionsSmallCheckButtonTemplate" )
		trackRepCheckBox:SetPoint("TOPLEFT" , ReputationDetailMainScreenCheckBox, "BOTTOMLEFT", 0, 4)
		trackRepCheckBox:SetSize(26,26)
		_G[trackRepCheckBox:GetName().."Text"]:SetText("Track with |cff20B020MiniHUD|r");
		trackRepCheckBox:SetScript("OnClick", Repper_CheckBox)
		trackRepCheckBox:Show()
	end
end

function SlashCmdList.Repper(msg)
	if (msg == '') then
		print('Repper: No Commands available yet.');
	elseif (msg == 'none') then
		print('Repper: Disabling all tracking');
		for k,v in pairs(RepList) do 
			v.Tracked = false
		end
		MyFuncs.Update(true)
	elseif (msg == 'on') then
		--REPPER:RegisterAllEvents()
		showEvent = true;
	elseif (msg == 'off') then
		--REPPER:UnregisterAllEvents()
		showEvent = false;
	elseif (string.sub(msg,0,3) == 'bar') then
		local id = tonumber(string.sub(msg, 5))
		if id == nil then 
			id = BarID + 1
			if id > #BarTextures then id = 0 end
		end
		if id < 0 or id > #BarTextures then return end;
		BarID = id
		print("Repper: Bar "..id..":"..BarTextures[BarID].Name.." selected.")
		RepperSavedBar = BarID
		MyFuncs.Update(true)
	end
end


_G[ADDONNAME] = MyFuncs -- put our functions in the global environment under our addon name so we can access them from the .xml as Repper.FunctionName

ReputationDetailFrame:HookScript("OnShow", Repper.HookDetailOnShow)
ReputationDetailFrame:HookScript("OnUpdate", Repper.HookDetailOnUpdate)


	-- -----------------------------------------------------------------------------------------
	-- --Keep for scroll frame example
	-- -----------------------------------------------------------------------------------------
	
	-- --Create Config Frame
	-- TrackingConfig = CreateFrame("Frame", "TrackingConfig", UIParent, "UIPanelDialogTemplate");
	-- TrackingConfig:SetSize(340,500);
	-- TrackingConfig:SetPoint("CENTER");--, anchorpoint, relativeTo, relativePoint);
	-- TrackingConfig:SetMovable(true);
	-- TrackingConfig:SetScript("OnMouseDown", TrackingConfig.StartMoving)
	-- TrackingConfig:SetScript("OnMouseUp", TrackingConfig.StopMovingOrSizing)
	-- --Set Config Frame Title
	-- TrackingConfig.Title:SetFontObject("GameFontHighlight");
	-- TrackingConfig.Title:ClearAllPoints();
	-- TrackingConfig.Title:SetPoint("TOPLEFT",TrackingConfigTitleBG,"TOPLEFT" , 6, -2);
	-- TrackingConfig.Title:SetText("Rep Tracking");
	-- --Set Scroll Frame
	-- TrackingConfig.ScrollFrame = CreateFrame("ScrollFrame", nil, TrackingConfig, "UIPanelScrollFrameTemplate");
	-- TrackingConfig.ScrollFrame:SetPoint("TOPLEFT", TrackingConfigDialogBG, "TOPLEFT", 4,-8);
	-- TrackingConfig.ScrollFrame:SetPoint("BOTTOMRIGHT", TrackingConfigDialogBG, "BOTTOMRIGHT", -25,4);
	-- TrackingConfig.ScrollChild = CreateFrame("Frame", nil, TrackingConfig.ScrollFrame);
	-- TrackingConfig.ScrollFrame:SetScrollChild(TrackingConfig.ScrollChild);
	-- TrackingConfig:Hide();
-- end